<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- artifact.qdoc -->
  <title>Artifact QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="next" href="qml-qbslanguageitems-depends.html" />
<p class="naviNextPrevious headerNavi">
<a class="nextPage" href="qml-qbslanguageitems-depends.html">Depends</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Artifact QML Type</h1>
<span class="subtitle"></span>
<!-- $$$Artifact-brief -->
<p>Describes a file produced by a Rule. <a href="#details">More...</a></p>
<!-- @@@Artifact -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsLanguageItems .</td></tr></table></div><ul>
<li><a href="qml-qbslanguageitems-artifact-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbslanguageitems-artifact.html#alwaysUpdated-prop">alwaysUpdated</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-artifact.html#filePath-prop">filePath</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-artifact.html#fileTags-prop">fileTags</a></b></b> : stringList</li>
</ul>
<!-- $$$Artifact-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>An Artifact represents a single file produced by a <a href="qml-qbslanguageitems-rule.html">Rule</a>.</p>
<p>For example, if a rule produces three files, it needs to contain three Artifact items.</p>
<p>In addition to Artifact properties, you can set module properties within an Artifact item, as follows:</p>
<pre class="cpp">

  Artifact {
      filePath: <span class="string">&quot;somefile.cpp&quot;</span>
      fileTags: <span class="operator">[</span><span class="string">&quot;cpp&quot;</span><span class="operator">]</span>
      cpp<span class="operator">.</span>cxxLanguageVersion: <span class="string">&quot;c++11&quot;</span>
      <span class="comment">// ...</span>
  }

</pre>
<p><b>Note: </b>The code on the right-hand side of Artifact properties has access to the set of input artifacts. That is, it can refer to the <code>inputs</code> map and, if the rule is not a multiplex rule, the <code>input</code> variable.</p><!-- @@@Artifact -->
<h2>Property Documentation</h2>
<!-- $$$alwaysUpdated -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="alwaysUpdated-prop">
<td class="tblQmlPropNode"><p>
<span class="name">alwaysUpdated</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Setting this property to <code>false</code> means the file is not necessarily always written to by any command run by the rule. If all artifacts of a rule have this property set to <code>false</code>, the commands of the rule are only executed if all of them are out of date compared to the inputs.</p>
<p>Default: <code>true</code></p>
</div></div><!-- @@@alwaysUpdated -->
<br/>
<!-- $$$filePath -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="filePath-prop">
<td class="tblQmlPropNode"><p>
<span class="name">filePath</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The file path of the target artifact.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@filePath -->
<br/>
<!-- $$$fileTags -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="fileTags-prop">
<td class="tblQmlPropNode"><p>
<span class="name">fileTags</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of tags to attach to the target file. These can then be matched by a <a href="qml-qbslanguageitems-rule.html">Rule</a>.</p>
<p>Default: An empty list</p>
</div></div><!-- @@@fileTags -->
<br/>
<p class="naviNextPrevious footerNavi">
<a class="nextPage" href="qml-qbslanguageitems-depends.html">Depends</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
